Smalltalk organization addCategory: 'HTML-Parser'!

Warning subclass: #DanglingCloseTagException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Parser'!

DanglingCloseTagException class
	instanceVariableNames: ''!

XMLNodeWithElements subclass: #HTMLDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Parser'!

HTMLDocument class
	instanceVariableNames: ''!

XMLElement subclass: #HTMLElement
	instanceVariableNames: 'hadCloseTag '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Parser'!

HTMLElement class
	instanceVariableNames: ''!

Object subclass: #HTMLParser
	instanceVariableNames: 'nodeStack '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Parser'!

HTMLParser class
	instanceVariableNames: ''!

TestCase subclass: #HTMLTestParser
	instanceVariableNames: 'tree '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Parser'!

HTMLTestParser class
	instanceVariableNames: ''!

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
aCanContain: aNode
	"<!!ELEMENT A - - (%inline;)* -(A)       -- anchor -->"

	^ aNode isInline and: [(aNode name = #a) not]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
aFontstyleOrPhraseCanContain: aNode
	"<!!ELEMENT (%fontstyle;|%phrase;) - - (%inline;)*>"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
aHeadingCanContain: aNode
	"<!!ELEMENT (%heading;)  - - (%inline;)* -- heading -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
addressCanContain: aNode
	"<!!ELEMENT ADDRESS - - (%inline;)* -- information on author -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
bdoCanContain: aNode
	"<!!ELEMENT BDO - - (%inline;)*          -- I18N BiDi over-ride -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
blockquoteCanContain: aNode
	"<!!ELEMENT BLOCKQUOTE - - (%block;|SCRIPT)+ -- long quotation -->"

	^ aNode isBlock or: [aNode name = #script]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 12/5/2002 17:31'!
bodyCanContain: aNode
	"<!!ELEMENT BODY O O (%block;|SCRIPT)+ +(INS|DEL) -- document body -->"

	^true! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
buttonCanContain: aNode
	"<!!ELEMENT BUTTON - -
     (%flow;)* -(A|%formctrl;|FORM|FIELDSET)
     -- push button -->"

	^ (aNode isFlow and: [aNode isFormctrl not])
			 and: [(#(a form fieldset) includes: aNode name) not]! !

!HTMLDocument methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 18:44'!
canContain: aNode
	^ true! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 12/2/2002 19:01'!
canContain: aNodeOrString

	"If name = nil then this is a dummy root node and can contain anything"
	name = nil ifTrue: [^ true].

	"These tags are defined as EMPTY in the dtd"
	self isAlwaysEmpty ifTrue: [^ false].
	
	"We assume we can always contain a string since we aren't defined as EMPTY"
	aNodeOrString isText ifTrue: [^ true].	
	aNodeOrString isKnownTag ifFalse: [^ true].

	" All the %fontstyle and %phrase tags are defined together,
		so we special case them:
	"
	(self isFontstyle | self isPhrase) ifTrue:
		[^ self class aFontstyleOrPhraseCanContain: aNodeOrString].

	" All the %heading tags are defined together so we special case them:"
	self isHeading ifTrue: [^ self class aHeadingCanContain: aNodeOrString].

	"Unkown parent elements need to accept everything because we
		know nothing about them.  This means that subcomponent tags
		must always be closed.  In other words html like '<p><foo><p>' will
		be parsed like '<p><foo><p></p></foo></p>' and NOT like <p><foo></foo></p><p></p>'
		as was probably expected."

	self isKnownTag ifFalse: [^true].

	^ self class perform: (self canContainSelector) with: aNodeOrString

! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 12/2/2002 19:01'!
canContainSelector
	^ (name, 'CanContain:') asSymbol.
! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
captionCanContain: aNode
	"<!!ELEMENT CAPTION  - - (%inline;)*     -- table caption -->"

	^ aNode isInline! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 7/21/2002 12:59'!
closeTag: aTag 
	| toClose |

	toClose _ nodeStack reversed
					detect: [:n | n name = aTag name asLowercase asSymbol]
					ifNone: [^ self danglingCloseTag: aTag].
	toClose hadCloseTag: true.
	nodeStack _ nodeStack copyUpTo: toClose.! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
colgroupCanContain: aNode
	"<!!ELEMENT COLGROUP - O (COL)*          -- table column group -->"

	^ aNode name = #col! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 17:41'!
danglingCloseTag: aTag
	DanglingCloseTagException signal:  'Close tag ', aTag source, ' with no open tag'! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
ddCanContain: aNode
	"<!!ELEMENT DD - O (%flow;)*             -- definition description -->"

	^ aNode isFlow! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
delCanContain: aNode
	"<!!ELEMENT (INS|DEL) - - (%flow;)*      -- inserted text, deleted text -->"

	^ aNode isFlow! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
divCanContain: aNode
	"<!!ELEMENT DIV - - (%flow;)*            -- generic language/style container -->"

	^ aNode isFlow! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
dlCanContain: aNode
	"<!!ELEMENT DL - - (DT|DD)+              -- definition list -->"

	^ #(dt dd) includes: aNode name! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:05'!
document
	^ nodeStack first! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
dtCanContain: aNode
	"<!!ELEMENT DT - O (%inline;)*           -- definition term -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
fieldsetCanContain: aNode
	"<!!ELEMENT FIELDSET - - (#PCDATA,LEGEND,(%flow;)*) -- form control group -->"

	^ aNode isFlow or: [aNode name = #legend]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
formCanContain: aNode
	"<!!ELEMENT FORM - - (%block;|SCRIPT)+ -(FORM) -- interactive form -->"

	^ (aNode isFlow or: [aNode name = #script])
		and: [aNode name ~= #form]! !

!HTMLElement class methodsFor: 'instance creation' stamp: 'ab 7/21/2002 12:59'!
fromTag: aTag
	^ super new initializeFromTag: aTag! !

!HTMLElement methodsFor: 'properties' stamp: 'ab 12/2/2002 18:59'!
hadCloseTag
	^ hadCloseTag ifNil: [hadCloseTag _ true]
! !

!HTMLElement methodsFor: 'properties' stamp: 'ab 7/21/2002 12:59'!
hadCloseTag: aBool
	hadCloseTag _ aBool
! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
headCanContain: aNode
	"<!!ENTITY % head.content 'TITLE & BASE?'>
	<!!ELEMENT HEAD O O (%head.content;) +(%head.misc;) -- document head -->"

	^ aNode isHeadMisc or: [#(title base) includes: aNode name]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
htmlCanContain: aNode
	"<!!ENTITY % html.content 'HEAD, BODY'>
	<!!ELEMENT HTML O O (%html.content;)    -- document root element -->"

	"since HEAD and BODY have optional open tags, we can allow their contents
	 as well"

	^ ((#(head body) includes: aNode name)
		or: [self headCanContain: aNode])
		or: [self bodyCanContain: aNode]! !

!HTMLElement methodsFor: 'initialization' stamp: 'ab 12/2/2002 19:00'!
initializeFromTag: aTag
	name _ aTag name asLowercase asSymbol.
	attributes _ aTag attribs.
	hadCloseTag _ false.
! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
insCanContain: aNode
	"<!!ELEMENT (INS|DEL) - - (%flow;)*      -- inserted text, deleted text -->"

	^ aNode isFlow! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 18:44'!
insert: aNode
	[nodeStack last canContain: aNode] whileFalse: [nodeStack removeLast].
	nodeStack last addElement: aNode.
	nodeStack add: aNode.! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isAlwaysEmpty

	^ (#(br area link img param hr input base meta col) includes: name)
"custom sea tags that don't need closing:"
		| (#(sea) includes: name)   ! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isBlock
	"<!!ENTITY % block
     'P | %heading; | %list; | %preformatted; | DL | DIV | NOSCRIPT |
      BLOCKQUOTE | FORM | HR | TABLE | FIELDSET | ADDRES'>"

	^ (self isHeading) 
		| (self isList) 
		| (self isPreformatted) 
		| (#(p dl div noscript blockquote form hr table fieldset address) includes: name)! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isFlow
	"<!!ENTITY % flow '%block; | %inline;'>"

	^ (self isBlock) 
		| (self isInline) ! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isFontstyle
	"<!!ENTITY % fontstyle 'TT | I | B | BIG | SMALL'>"

	^ #( tt i b big small) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isFormctrl
	"<!!ENTITY % formctrl 'INPUT | SELECT | TEXTAREA | LABEL | BUTTON'>"

	^ #(input select textarea label button) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isHeadMisc
	"<!!ENTITY % head.misc 'SCRIPT|STYLE|META|LINK|OBJECT' -- repeatable head elements -->"

	^ #(script style meta link object) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isHeading
	"<!!ENTITY % heading 'H1|H2|H3|H4|H5|H6'>"

	^ #(h1 h2 h3 h4 h5 h6) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isHtmlContent
	"<!!ENTITY % html.content 'HEAD, BODY'>"

	"We don't enforce the order of tags - we're not validating"	

	^ #(head body) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isInline
	"<!!ENTITY % inline '#PCDATA | %fontstyle; | %phrase; | %special; | %formctrl;'>"

	^ self isFontstyle
		| self isPhrase
		| self isSpecial
		| self isFormctrl! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 12/2/2002 19:01'!
isKnownTag
	self isAlwaysEmpty ifTrue: [^true].
	self isPhrase ifTrue: [^true].
	self isFontstyle ifTrue: [^true].
	self isHeading ifTrue: [^true].
	^ self class respondsTo: (self canContainSelector)! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isList
	"<!!ENTITY % list 'UL | OL'>"

	^ #(ul ol) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isPhrase
	"<!!ENTITY % phrase 'EM | STRONG | DFN | CODE |
                   SAMP | KBD | VAR | CITE | ABBR | ACRONYM' >"

	^ #(em strong dfn code samp kbd var cite abbr acronym) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isPreExclusion
	"<!!-- excludes markup for images and changes in font size -->
	<!!ENTITY % pre.exclusion 'IMG|OBJECT|BIG|SMALL|SUB|SUP'>"

	^ #(img object big small sub sup) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isPreformatted
	"<!!ENTITY % preformatted 'PRE'>"

	^ #(pre) includes: name! !

!HTMLElement methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
isSpecial
	"<!!ENTITY % special
   'A | IMG | OBJECT | BR | SCRIPT | MAP | Q | SUB | SUP | SPAN | BDO'>"

	^ #(a img object br script map q sub sup span bdo) includes: name! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
labelCanContain: aNode
	"<!!ELEMENT LABEL - - (%inline;)* -(LABEL) -- form field label text -->"

	^ aNode isInline  and: [aNode name ~= #label]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
legendCanContain: aNode
	"<!!ELEMENT LEGEND - - (%inline;)*       -- fieldset legend -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
liCanContain: aNode
	"<!!ELEMENT LI - O (%flow;)*             -- list item -->"

	^ aNode isFlow! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
mapCanContain: aNode
	"<!!ELEMENT MAP - - ((%block;) | AREA)+ -- client-side image map -->"

	^ aNode isBlock or: [aNode name = #area]! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 7/21/2002 12:59'!
nextTag: aTag 
	aTag isNegated
		ifTrue: [self closeTag: aTag]
		ifFalse: [self openTag: aTag]! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 17:28'!
nextText: aString
	aString isAllSeparators ifFalse:
		[self insert: (XMLStringNode string: aString).  "leaves aString on the stack"
		nodeStack removeLast]! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 7/21/2002 12:59'!
nextToken: aToken 
	aToken isTag
		ifTrue: [self nextTag: aToken]
		ifFalse: [self nextText: aToken source]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
noscriptCanContain: aNode
	"<!!ELEMENT NOSCRIPT - - (%block;)+
  	-- alternate content container for non script-based rendering -->"

	^ aNode isBlock! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
objectCanContain: aNode
	"<!!ELEMENT OBJECT - - (PARAM | %flow;)* -- generic embedded object -->"

	^ aNode isFlow or: [aNode name = #param]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
olCanContain: aNode
	"<!!ELEMENT OL - - (LI)+                 -- ordered list -->"

	^ aNode name = #li! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 18:49'!
openTag: aTag
	self insert: (HTMLElement fromTag: aTag).
! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
optgroupCanContain: aNode
	"<!!ELEMENT OPTGROUP - - (OPTION)+ -- option group -->"

	^ aNode name = #option! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
optionCanContain: aNode
	"<!!ELEMENT OPTION - O (#PCDATA)         -- selectable choice -->"

	"we handled the case of a String in #canContain so we can return false"

	^ false! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
pCanContain: aNode
	"<!!ELEMENT P - O (%inline;)*            -- paragraph -->"

	^ aNode isInline! !

!HTMLParser class methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
parseDocumentFrom: aStringOrStream
	^ (self new parseStream: aStringOrStream) document! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 11/28/2002 12:02'!
parseStream: aStream
	self parseTokens: (HtmlTokenizer on: aStream)! !

!HTMLParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 18:47'!
parseTokens: tokenStream 
	nodeStack _ OrderedCollection with: HTMLDocument new.
	[tokenStream atEnd]
		whileFalse: [self nextToken: tokenStream next].
! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
preCanContain: aNode
	"<!!ELEMENT PRE - - (%inline;)* -(%pre.exclusion;) -- preformatted text -->"

	^ aNode isInline and: [(aNode isPreExclusion) not]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
qCanContain: aNode
	"<!!ELEMENT Q - - (%inline;)*            -- short inline quotation -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
scriptCanContain: aNode
	"<!!ELEMENT SCRIPT - - %Script;          -- script statements -->"

	"%Script is defined earlier as CDATA so we only allow text"

	^ false! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
selectCanContain: aNode
	"<!!ELEMENT SELECT - - (OPTGROUP|OPTION)+ -- option selector -->"

	^ aNode name = #optgroup or: [aNode name = #option]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
spanCanContain: aNode
	"<!!ELEMENT SPAN - - (%inline;)*         -- generic language/style container -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
styleCanContain: aNode
	"<!!ELEMENT STYLE - - %StyleSheet        -- style info -->"

	"%StyleSheet is defined earlier as CDATA so we only allow text"

	^ false! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
subCanContain: aNode
	"<!!ELEMENT (SUB|SUP) - - (%inline;)*    -- subscript, superscript -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
supCanContain: aNode
	"<!!ELEMENT (SUB|SUP) - - (%inline;)*    -- subscript, superscript -->"

	^ aNode isInline! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
tableCanContain: aNode
	"<!!ELEMENT TABLE - -
     (CAPTION?, (COL*|COLGROUP*), THEAD?, TFOOT?, TBODY+)>"

	"since TBODY has optional open and close tags, we're allowing
		TR to reside directly inside TABLE for simplicity. This is how
		most people write html anyway and works fine except in the
		case where both a TR and a TBODY reside directly inside a TABLE.
		But then the user was writing non-conformant code anyway and
		we should just pass it through for the browser to maybe choke on"

	^ (#(caption col colgroup thead tfoot tbody) includes: aNode name)
			or: [self tbodyCanContain: aNode]! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
tbodyCanContain: aNode
	"<!!ELEMENT TBODY    O O (TR)+           -- table body -->"

	^ aNode name = #tr! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
tdCanContain: aNode
	"<!!ELEMENT (TH|TD)  - O (%flow;)*       -- table header cell, table data cell-->"

	^ aNode isFlow! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 17:39'!
testBrokenFormNesting
	|text|
	text _ '<table><tr><form><td>foo</td></tr></form></table>'.
	self should: [ HTMLParser parseDocumentFrom: text] raise: DanglingCloseTagException! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 17:38'!
testBrokenNesting
	self
		should: [ HTMLParser parseDocumentFrom: '<b>hello world</b><i><b>goodbye world</i></b>']
		raise: DanglingCloseTagException.! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testComments
	tree _ HTMLParser parseDocumentFrom: '<!!-- hello -->'.
	self assert: tree elements size = 1.
	self assert: tree elements first string = '<!!-- hello -->'.! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testForm
	|select|
	tree _ HTMLParser parseDocumentFrom: '<form><input>foo<br><input>bar</form>'.
	self assert: (tree elements size = 1).
	select _ tree elements first.
	self assert: select name = #form.
	self assert: select elements size = 5.
	self assert: select elements first name = #input.
	! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testNestedList
	|ul li1 ul2|
	tree _ HTMLParser parseDocumentFrom: '<ul><li><ul><li>1</li><li>2</ul><li>3</ul>'.
	self assert: (tree elements size = 1).
	ul _ tree elements first.
	self assert: (ul name = #ul).
	self assert: (ul elements size = 2).
	li1 _ ul elements first.
	self assert: (li1 name = #li).
	self assert: (li1 elements size = 1).
	ul2 _ li1 elements first.
	self assert: (ul2 name = #ul).
	self assert: (ul2 elements size = 2).
	self assert: (ul2 elements first elements first string = '1').! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testNestedTables
	|tr2|
	tree _ HTMLParser parseDocumentFrom: '<tr><td>foo<table><tr></tr></table><tr><td>row2'.
	self assert: (tree elements size = 2).
	tr2 _ tree elements last.
	self assert: (tr2 name = #tr).
	self assert: (tr2 elements size = 1).
	self assert: (tr2 elements first elements first string = 'row2').! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testRoot
	tree _ HTMLParser parseDocumentFrom: 'hello world'.
	self assert: (tree elements size = 1).
	self assert: (tree elements first string = 'hello world').
	! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testSelect
	|select|
	tree _ HTMLParser parseDocumentFrom: '<select><option>foo<option>bar</select>'.
	self assert: (tree elements size = 1).
	select _ tree elements first.
	self assert: select name = #select.
	self assert: select elements size = 2.
	self assert: select elements first name = #option.
	! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testSimpleNesting
	tree _ HTMLParser parseDocumentFrom: '<b>hello world</b><i><b>goodbye world</b></i>'.
	self assert: (tree elements size = 2).
	self assert: (tree elements first name = #b).
	self assert: (tree elements last name = #i).
	! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testSuccessiveParagraphs
	|p1|
	tree _ HTMLParser parseDocumentFrom: '<p>this is a test<p>this is another test'.
	self assert: (tree elements size = 2).
	self assert: (tree elements first name = #p).
	p1 _ tree elements first.
	self assert: (p1 name = #p).
	self assert: (p1 elements size = 1).
	self assert: (p1 elements first string = 'this is a test').! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testUnkownChildElement
	"Presumably we need to support unknown elements going anywhere since
		they could be subcomponents"

	tree _ HTMLParser parseDocumentFrom: '<p>text1<blah>text2</blah>text3</p>'.
	self assert: (tree elements size = 1).
	self assert: (tree elements first name = #p).
	self assert: (tree elements first elements size = 3).
	self assert: (tree elements first elements first string = 'text1').
	self assert: (tree elements first elements second name = #blah).
	self assert: (tree elements first elements second elements size = 1).
	self assert: (tree elements first elements second elements first string = 'text2').
	self assert: (tree elements first elements third string = 'text3').
	! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testUnkownParentElement
	"Unkown parent elements need to accept everything because we
		know nothing about them.  This means that subcomponent tags
		must always be closed.  In other words html like '<p><foo><p>' will
		be parsed like '<p><foo><p></p></foo></p>' and NOT like <p><foo></foo></p><p></p>'
		as was probably expected."

	tree _ HTMLParser parseDocumentFrom: '<blah><p></p><li></li><foo></foo></blah>'.
	self assert: (tree elements size = 1).
	self assert: (tree elements first name = #blah).
	self assert: (tree elements first elements size = 3).
	self assert: (tree elements first elements first name = #p).
	self assert: (tree elements first elements second name = #li).
	self assert: (tree elements first elements third name = #foo).
	! !

!HTMLTestParser methodsFor: 'as yet unclassified' stamp: 'ab 12/2/2002 19:07'!
testUnorderedList
	|ul li1|
	tree _ HTMLParser parseDocumentFrom: '<ul><li>1<li>2<li>3</ul>'.
	self assert: (tree elements size = 1).
	ul _ tree elements first.
	self assert: (ul name = #ul).
	self assert: (ul elements size = 3).
	li1 _ ul elements first.
	self assert: (li1 name = #li).
	self assert: (li1 elements size = 1).
	self assert: (li1 elements first string = '1').
	! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
textareaCanContain: aNode
	"<!!ELEMENT TEXTAREA - - (#PCDATA)       -- multi-line text field -->"

	"we handled the case of a String in #canContain so we can return false"

	^ false! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
tfootCanContain: aNode
	"<!!ELEMENT TFOOT    - O (TR)+           -- table footer -->"

	^ aNode name = #tr! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
thCanContain: aNode
	"<!!ELEMENT (TH|TD)  - O (%flow;)*       -- table header cell, table data cell-->"

	^ aNode isFlow! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
theadCanContain: aNode
	"<!!ELEMENT THEAD    - O (TR)+           -- table header -->"

	^ aNode name = #tr! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
titleCanContain: aNode
	"<!!ELEMENT TITLE - - (#PCDATA) -(%head.misc;) -- document title -->"

	"not sure about this one... why do we need to specifically remove %head.misc
	from PCDATA which has to tags?  can PCDATA include text that looks like tags
	but isn't? ie: <title><p>blah</p></title is valid and would actually print 
	'<p>blah</p>' in the title bar.  If so then we may need to catch this case to
	make sure all tags just get interpreted as text in here... dunno how though"

	"returning false for now"

	^ false! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
trCanContain: aNode
	"<!!ELEMENT TR       - O (TH|TD)+        -- table row -->"

	^ #(th td) includes: aNode name! !

!HTMLElement class methodsFor: 'html spec def' stamp: 'ab 7/21/2002 12:59'!
ulCanContain: aNode
	"<!!ELEMENT UL - - (LI)+                 -- unordered list -->"

	^ aNode name = #li! !

Smalltalk at: #FilePackageManager ifPresent: [:p | p registerPackage: 'HTML-Parser'].!

